<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>section 1.7: Functions</title>
<link href="sx4j.html" rev=precedes>
<link href="sx4l.html" rel=precedes>
<link href="sx4.html" rev=subdocument>
</head>
<body>
<H2>section 1.7: Functions</H2>

page 24
<p>Deep sentence:
<blockquote>...you will often see a short function defined and called only once,
just because it clarifies some piece of code.
</blockquote>Ideally, this is true in any language.
Breaking a program up into functions
(or subroutines or procedures or whatever a language calls them)
is one of the first and one of the most important ways
to keep control of the proliferating complexity in a software 
project.
</p><p>page 25
</p><p>Note that the <TT>for</TT> loop at the top of the page runs from 
<TT>1</TT> to <TT>n</TT> rather than <TT>0</TT> to <TT>n-1</TT>,
and may therefore seem suspect by the above note for page 22.
In this case, since all that matters is that the loop is 
traversed <TT>n</TT> times,
it doesn't matter which values <TT>i</TT> takes on.
</p><p>Not only the names of the parameters and local variables,
but also their values
(as we'll see in section 1.8),
are all local to a function.
Rather than remembering a list of things that are local,
it's easier to remember that <em>everything</em> is local:
the whole point of a function as an abstraction mechanism is 
that it's a black box; you don't have to know or care about
any of its implementation details,
such as what it chooses to name its parameters and local 
variables.
You pass it some arguments, and it returns you a value 
according to its specification.
</p><p>The distinction between the terms <dfn>argument</dfn> and 
<dfn>parameter</dfn> may seem overly picky, but it's a good way of 
reinforcing the notion that the parameters and other details of 
a function's implementation are almost completely separated from
(that is, of no concern to)
the caller.
</p><p>page 26
</p><p>Note the discussion about return values from <TT>main</TT>.
The first few sample programs in this chapter,
including the very first ``hello, world'' example on page 6,
have omitted a return value,
which is, stricly speaking, incorrect.
Do get in the habit of returning a value from <TT>main</TT>,
both to be correct,
and because
``programs should return status to their environment.''
</p><p>By ``Parameter names need not agree''
they mean that it's not a problem that the prototype 
declaration of <TT>power</TT> says that the first parameter is 
named <TT>m</TT>,
while the actual function definition that it's named <TT>base</TT>.
</p><p>pages 26-7
</p><p>It's probably a good idea if you're aware of this ``old style'' 
function syntax,
so that you won't be taken aback when you come across it,
perhaps in code written by
reactionary old fogies
(such as the author of these notes)
who still tend to use it out of habit when they're not paying attention.
</p><hr>
<p>
Read sequentially:
<a href="sx4j.html" rev=precedes>prev</a>
<a href="sx4l.html" rel=precedes>next</a>
<a href="sx4.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
